<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>OpenThread: src/core/mac/mac_frame.hpp Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="../../Open-Thread-Logo-200x42.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">
   &#160;<span id="projectnumber">gddd0704</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="../../index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="../../modules.html"><span>Modules</span></a></li>
      <li><a href="../../namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="../../annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="../../files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="../../search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="../../search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="../../files.html"><span>File&#160;List</span></a></li>
      <li><a href="../../globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('d1/d97/mac__frame_8hpp_source.html','../../');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">mac_frame.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="../../d1/d97/mac__frame_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> *  Copyright (c) 2016, The OpenThread Authors.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *  All rights reserved.</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *  Redistribution and use in source and binary forms, with or without</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> *  modification, are permitted provided that the following conditions are met:</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *  1. Redistributions of source code must retain the above copyright</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     notice, this list of conditions and the following disclaimer.</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *  2. Redistributions in binary form must reproduce the above copyright</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> *     notice, this list of conditions and the following disclaimer in the</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> *     documentation and/or other materials provided with the distribution.</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> *  3. Neither the name of the copyright holder nor the</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *     names of its contributors may be used to endorse or promote products</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *     derived from this software without specific prior written permission.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS &quot;AS IS&quot;</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> *  POSSIBILITY OF SUCH DAMAGE.</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#ifndef MAC_FRAME_HPP_</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#define MAC_FRAME_HPP_</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#include &lt;limits.h&gt;</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="preprocessor">#include &lt;stdint.h&gt;</span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="preprocessor">#include &lt;string.h&gt;</span></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../df/d57/encoding_8hpp.html">common/encoding.hpp</a>&gt;</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../dc/dbf/openthread-types_8h.html">openthread-types.h</a>&gt;</span></div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../d7/d62/radio_8h.html">platform/radio.h</a>&gt;</span></div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="keyword">namespace </span><a class="code" href="../../d9/d00/namespaceThread.html">Thread</a> {</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="keyword">namespace </span>Ip6 { <span class="keyword">class </span>Address; }</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="keyword">namespace </span>Mac {</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="keyword">enum</span></div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;{</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    kShortAddrBroadcast = 0xffff,</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    kShortAddrInvalid = 0xfffe,</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    kPanIdBroadcast = 0xffff,</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;};</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;</div><div class="line"><a name="l00069"></a><span class="lineno"><a class="line" href="../../df/d5c/group__core-mac.html#gafb4cc58e5e57ede04e2dbeb02f230ae1">   69</a></span>&#160;<span class="keyword">typedef</span> <a class="code" href="../../dc/dbf/openthread-types_8h.html#a2dd7c7e7e4b5a8a15e9af7fb78de1eda">otPanId</a> <a class="code" href="../../df/d5c/group__core-mac.html#gafb4cc58e5e57ede04e2dbeb02f230ae1">PanId</a>;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div><div class="line"><a name="l00075"></a><span class="lineno"><a class="line" href="../../df/d5c/group__core-mac.html#ga70635fe32761138510f029f3d4eb36b7">   75</a></span>&#160;<span class="keyword">typedef</span> <a class="code" href="../../dc/dbf/openthread-types_8h.html#a9199b7f0fe13ebcd0da2e3af71f04c40">otShortAddress</a> <a class="code" href="../../df/d5c/group__core-mac.html#ga70635fe32761138510f029f3d4eb36b7">ShortAddress</a>;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div><div class="line"><a name="l00081"></a><span class="lineno"><a class="line" href="../../d9/d3c/classThread_1_1Mac_1_1ExtAddress.html">   81</a></span>&#160;<span class="keyword">class </span><a class="code" href="../../d9/d3c/classThread_1_1Mac_1_1ExtAddress.html">ExtAddress</a>: <span class="keyword">public</span> <a class="code" href="../../d3/d8f/structotExtAddress.html">otExtAddress</a></div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;{</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00091"></a><span class="lineno"><a class="line" href="../../d9/d3c/classThread_1_1Mac_1_1ExtAddress.html#a0dc2551c0ecb13f87ab257c4c760396b">   91</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="../../d9/d3c/classThread_1_1Mac_1_1ExtAddress.html#a0dc2551c0ecb13f87ab257c4c760396b">IsGroup</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (m8[0] &amp; kGroupFlag) != 0; }</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;</div><div class="line"><a name="l00099"></a><span class="lineno"><a class="line" href="../../d9/d3c/classThread_1_1Mac_1_1ExtAddress.html#a46495e874468bb305e1e3ddc410a16d0">   99</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../d9/d3c/classThread_1_1Mac_1_1ExtAddress.html#a46495e874468bb305e1e3ddc410a16d0">SetGroup</a>(<span class="keywordtype">bool</span> aGroup) {</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        <span class="keywordflow">if</span> (aGroup) {</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;            m8[0] |= kGroupFlag;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        }</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        <span class="keywordflow">else</span> {</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;            m8[0] &amp;= ~kGroupFlag;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        }</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    }</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;</div><div class="line"><a name="l00115"></a><span class="lineno"><a class="line" href="../../d9/d3c/classThread_1_1Mac_1_1ExtAddress.html#a43917c9fe781b643eb1309b047c9d08b">  115</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="../../d9/d3c/classThread_1_1Mac_1_1ExtAddress.html#a43917c9fe781b643eb1309b047c9d08b">IsLocal</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (m8[0] &amp; kLocalFlag) != 0; }</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div><div class="line"><a name="l00123"></a><span class="lineno"><a class="line" href="../../d9/d3c/classThread_1_1Mac_1_1ExtAddress.html#a846827d778c476fb5c5c059903efc4fb">  123</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../d9/d3c/classThread_1_1Mac_1_1ExtAddress.html#a846827d778c476fb5c5c059903efc4fb">SetLocal</a>(<span class="keywordtype">bool</span> aLocal) {</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        <span class="keywordflow">if</span> (aLocal) {</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;            m8[0] |= kLocalFlag;</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;        }</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;        <span class="keywordflow">else</span> {</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;            m8[0] &amp;= ~kLocalFlag;</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;        }</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    }</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;    <span class="keywordtype">void</span> Set(<span class="keyword">const</span> <a class="code" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Ip6::Address</a> &amp;aIpAddress);</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;    <span class="keyword">enum</span></div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;    {</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        kGroupFlag = 1 &lt;&lt; 0,</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;        kLocalFlag = 1 &lt;&lt; 1,</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    };</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;};</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;</div><div class="line"><a name="l00152"></a><span class="lineno"><a class="line" href="../../dd/dcd/structThread_1_1Mac_1_1Address.html">  152</a></span>&#160;<span class="keyword">struct </span><a class="code" href="../../dd/dcd/structThread_1_1Mac_1_1Address.html">Address</a></div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;{</div><div class="line"><a name="l00154"></a><span class="lineno"><a class="line" href="../../dd/dcd/structThread_1_1Mac_1_1Address.html#af0811fa6871a4011a107fe7416f4b09e">  154</a></span>&#160;    uint8_t <a class="code" href="../../dd/dcd/structThread_1_1Mac_1_1Address.html#af0811fa6871a4011a107fe7416f4b09e">mLength</a>;                 </div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;    <span class="keyword">union</span></div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;    {</div><div class="line"><a name="l00157"></a><span class="lineno"><a class="line" href="../../dd/dcd/structThread_1_1Mac_1_1Address.html#aeec7c8fde272afa865ba668174335040">  157</a></span>&#160;        ShortAddress <a class="code" href="../../dd/dcd/structThread_1_1Mac_1_1Address.html#aeec7c8fde272afa865ba668174335040">mShortAddress</a>;  </div><div class="line"><a name="l00158"></a><span class="lineno"><a class="line" href="../../dd/dcd/structThread_1_1Mac_1_1Address.html#a349a0360c664b5aefef89bb537b810d3">  158</a></span>&#160;        <a class="code" href="../../d9/d3c/classThread_1_1Mac_1_1ExtAddress.html">ExtAddress</a> <a class="code" href="../../dd/dcd/structThread_1_1Mac_1_1Address.html#a349a0360c664b5aefef89bb537b810d3">mExtAddress</a>;      </div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    };</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;};</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;<a class="code" href="../../d7/da1/group__toolchain.html#gaba6ad63129c3a790957a9b149a65891b">OT_TOOL_PACKED_BEGIN</a></div><div class="line"><a name="l00167"></a><span class="lineno"><a class="line" href="../../d5/d19/classThread_1_1Mac_1_1Frame.html">  167</a></span>&#160;<span class="keyword">class </span><a class="code" href="../../d5/d19/classThread_1_1Mac_1_1Frame.html">Frame</a>: <span class="keyword">public</span> <a class="code" href="../../db/ddc/structRadioPacket.html">RadioPacket</a></div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;{</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;    <span class="keyword">enum</span></div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    {</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;        kMTU                  = 127,</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;        kFcfSize              = <span class="keyword">sizeof</span>(uint16_t),</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;        kDsnSize              = <span class="keyword">sizeof</span>(uint8_t),</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;        kSecurityControlSize  = <span class="keyword">sizeof</span>(uint8_t),</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;        kFrameCounterSize     = <span class="keyword">sizeof</span>(uint32_t),</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;        kCommandIdSize        = <span class="keyword">sizeof</span>(uint8_t),</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;        kFcsSize              = <span class="keyword">sizeof</span>(uint16_t),</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;        kFcfFrameBeacon       = 0 &lt;&lt; 0,</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        kFcfFrameData         = 1 &lt;&lt; 0,</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;        kFcfFrameAck          = 2 &lt;&lt; 0,</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;        kFcfFrameMacCmd       = 3 &lt;&lt; 0,</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;        kFcfFrameTypeMask     = 7 &lt;&lt; 0,</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;        kFcfSecurityEnabled   = 1 &lt;&lt; 3,</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;        kFcfFramePending      = 1 &lt;&lt; 4,</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;        kFcfAckRequest        = 1 &lt;&lt; 5,</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;        kFcfPanidCompression  = 1 &lt;&lt; 6,</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;        kFcfDstAddrNone       = 0 &lt;&lt; 10,</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;        kFcfDstAddrShort      = 2 &lt;&lt; 10,</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;        kFcfDstAddrExt        = 3 &lt;&lt; 10,</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;        kFcfDstAddrMask       = 3 &lt;&lt; 10,</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;        kFcfFrameVersion2006  = 1 &lt;&lt; 12,</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;        kFcfFrameVersionMask  = 3 &lt;&lt; 13,</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;        kFcfSrcAddrNone       = 0 &lt;&lt; 14,</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;        kFcfSrcAddrShort      = 2 &lt;&lt; 14,</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;        kFcfSrcAddrExt        = 3 &lt;&lt; 14,</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;        kFcfSrcAddrMask       = 3 &lt;&lt; 14,</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;        kSecNone              = 0 &lt;&lt; 0,</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        kSecMic32             = 1 &lt;&lt; 0,</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;        kSecMic64             = 2 &lt;&lt; 0,</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;        kSecMic128            = 3 &lt;&lt; 0,</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        kSecEnc               = 4 &lt;&lt; 0,</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;        kSecEncMic32          = 5 &lt;&lt; 0,</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;        kSecEncMic64          = 6 &lt;&lt; 0,</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;        kSecEncMic128         = 7 &lt;&lt; 0,</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;        kSecLevelMask         = 7 &lt;&lt; 0,</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;        kMic0Size             = 0,</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;        kMic32Size            = 32 / CHAR_BIT,</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;        kMic64Size            = 64 / CHAR_BIT,</div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;        kMic128Size           = 128 / CHAR_BIT,</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;        kMaxMicSize           = kMic128Size,</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;        kKeyIdMode0           = 0 &lt;&lt; 3,</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;        kKeyIdMode1           = 1 &lt;&lt; 3,</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;        kKeyIdMode2           = 2 &lt;&lt; 3,</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;        kKeyIdMode3           = 3 &lt;&lt; 3,</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;        kKeyIdModeMask        = 3 &lt;&lt; 3,</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;        kMacCmdAssociationRequest          = 1,</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;        kMacCmdAssociationResponse         = 2,</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;        kMacCmdDisassociationNotification  = 3,</div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;        kMacCmdDataRequest                 = 4,</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;        kMacCmdPanidConflictNotification   = 5,</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;        kMacCmdOrphanNotification          = 6,</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;        kMacCmdBeaconRequest               = 7,</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;        kMacCmdCoordinatorRealignment      = 8,</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;        kMacCmdGtsRequest                  = 9,</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;    };</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> InitMacHeader(uint16_t aFcf, uint8_t aSecCtl);</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;    uint8_t GetType(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;    <span class="keywordtype">bool</span> GetSecurityEnabled(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;    <span class="keywordtype">bool</span> GetFramePending(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;    <span class="keywordtype">void</span> SetFramePending(<span class="keywordtype">bool</span> aFramePending);</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;    <span class="keywordtype">bool</span> GetAckRequest(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;    <span class="keywordtype">void</span> SetAckRequest(<span class="keywordtype">bool</span> aAckRequest);</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;</div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;    uint8_t GetSequence(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;    <span class="keywordtype">void</span> SetSequence(uint8_t aSequence);</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> GetDstPanId(PanId &amp;aPanId);</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;</div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SetDstPanId(PanId aPanId);</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> GetDstAddr(<a class="code" href="../../dd/dcd/structThread_1_1Mac_1_1Address.html">Address</a> &amp;aAddress);</div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SetDstAddr(ShortAddress aShortAddress);</div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;</div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SetDstAddr(<span class="keyword">const</span> <a class="code" href="../../d9/d3c/classThread_1_1Mac_1_1ExtAddress.html">ExtAddress</a> &amp;aExtAddress);</div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;</div><div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> GetSrcPanId(PanId &amp;aPanId);</div><div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;</div><div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SetSrcPanId(PanId aPanId);</div><div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;</div><div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> GetSrcAddr(<a class="code" href="../../dd/dcd/structThread_1_1Mac_1_1Address.html">Address</a> &amp;aAddress);</div><div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;</div><div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SetSrcAddr(ShortAddress aShortAddress);</div><div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160;</div><div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SetSrcAddr(<span class="keyword">const</span> <a class="code" href="../../d9/d3c/classThread_1_1Mac_1_1ExtAddress.html">ExtAddress</a> &amp;aExtAddress);</div><div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;</div><div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> GetSecurityLevel(uint8_t &amp;aSecurityLevel);</div><div class="line"><a name="l00421"></a><span class="lineno">  421</span>&#160;</div><div class="line"><a name="l00430"></a><span class="lineno">  430</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> GetKeyIdMode(uint8_t &amp;aKeyIdMode);</div><div class="line"><a name="l00431"></a><span class="lineno">  431</span>&#160;</div><div class="line"><a name="l00440"></a><span class="lineno">  440</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> GetFrameCounter(uint32_t &amp;aFrameCounter);</div><div class="line"><a name="l00441"></a><span class="lineno">  441</span>&#160;</div><div class="line"><a name="l00450"></a><span class="lineno">  450</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SetFrameCounter(uint32_t aFrameCounter);</div><div class="line"><a name="l00451"></a><span class="lineno">  451</span>&#160;</div><div class="line"><a name="l00460"></a><span class="lineno">  460</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> GetKeyId(uint8_t &amp;aKeyId);</div><div class="line"><a name="l00461"></a><span class="lineno">  461</span>&#160;</div><div class="line"><a name="l00470"></a><span class="lineno">  470</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SetKeyId(uint8_t aKeyId);</div><div class="line"><a name="l00471"></a><span class="lineno">  471</span>&#160;</div><div class="line"><a name="l00480"></a><span class="lineno">  480</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> GetCommandId(uint8_t &amp;aCommandId);</div><div class="line"><a name="l00481"></a><span class="lineno">  481</span>&#160;</div><div class="line"><a name="l00490"></a><span class="lineno">  490</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SetCommandId(uint8_t aCommandId);</div><div class="line"><a name="l00491"></a><span class="lineno">  491</span>&#160;</div><div class="line"><a name="l00498"></a><span class="lineno">  498</span>&#160;    uint8_t GetLength(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div><div class="line"><a name="l00499"></a><span class="lineno">  499</span>&#160;</div><div class="line"><a name="l00509"></a><span class="lineno">  509</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SetLength(uint8_t aLength);</div><div class="line"><a name="l00510"></a><span class="lineno">  510</span>&#160;</div><div class="line"><a name="l00517"></a><span class="lineno">  517</span>&#160;    uint8_t GetHeaderLength(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00518"></a><span class="lineno">  518</span>&#160;</div><div class="line"><a name="l00525"></a><span class="lineno">  525</span>&#160;    uint8_t GetFooterLength(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00526"></a><span class="lineno">  526</span>&#160;</div><div class="line"><a name="l00533"></a><span class="lineno">  533</span>&#160;    uint8_t GetPayloadLength(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00534"></a><span class="lineno">  534</span>&#160;</div><div class="line"><a name="l00541"></a><span class="lineno">  541</span>&#160;    uint8_t GetMaxPayloadLength(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00542"></a><span class="lineno">  542</span>&#160;</div><div class="line"><a name="l00550"></a><span class="lineno">  550</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> SetPayloadLength(uint8_t aLength);</div><div class="line"><a name="l00551"></a><span class="lineno">  551</span>&#160;</div><div class="line"><a name="l00558"></a><span class="lineno"><a class="line" href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#ac3d7050937855b460dca12d48568b47c">  558</a></span>&#160;    uint8_t <a class="code" href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#ac3d7050937855b460dca12d48568b47c">GetChannel</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mChannel; }</div><div class="line"><a name="l00559"></a><span class="lineno">  559</span>&#160;</div><div class="line"><a name="l00566"></a><span class="lineno"><a class="line" href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#a93887aa34760b4de326cee1ff3d83b75">  566</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#a93887aa34760b4de326cee1ff3d83b75">SetChannel</a>(uint8_t aChannel) { mChannel = aChannel; }</div><div class="line"><a name="l00567"></a><span class="lineno">  567</span>&#160;</div><div class="line"><a name="l00574"></a><span class="lineno"><a class="line" href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#a610b5a57124838a4e45ea7c4ec702166">  574</a></span>&#160;    int8_t <a class="code" href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#a610b5a57124838a4e45ea7c4ec702166">GetPower</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mPower; }</div><div class="line"><a name="l00575"></a><span class="lineno">  575</span>&#160;</div><div class="line"><a name="l00582"></a><span class="lineno"><a class="line" href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#a0eeddf23b24e968ad5c025b0143dcc4a">  582</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#a0eeddf23b24e968ad5c025b0143dcc4a">SetPower</a>(int8_t aPower) { mPower = aPower; }</div><div class="line"><a name="l00583"></a><span class="lineno">  583</span>&#160;</div><div class="line"><a name="l00590"></a><span class="lineno"><a class="line" href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#a1d0d834e9d25cd755f00b0de75ba9f89">  590</a></span>&#160;    uint8_t <a class="code" href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#a1d0d834e9d25cd755f00b0de75ba9f89">GetLqi</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mLqi; }</div><div class="line"><a name="l00591"></a><span class="lineno">  591</span>&#160;</div><div class="line"><a name="l00598"></a><span class="lineno"><a class="line" href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#a09c3c9cbba9064e95c0224a637920930">  598</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#a09c3c9cbba9064e95c0224a637920930">SetLqi</a>(uint8_t aLqi) { mLqi = aLqi; }</div><div class="line"><a name="l00599"></a><span class="lineno">  599</span>&#160;</div><div class="line"><a name="l00607"></a><span class="lineno"><a class="line" href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#a3bfa54c09049320ffa71d29d413ba223">  607</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#a3bfa54c09049320ffa71d29d413ba223">GetSecurityValid</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSecurityValid; }</div><div class="line"><a name="l00608"></a><span class="lineno">  608</span>&#160;</div><div class="line"><a name="l00615"></a><span class="lineno"><a class="line" href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#adad1e326ec1c3bf027a0e6e485f178b8">  615</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#adad1e326ec1c3bf027a0e6e485f178b8">SetSecurityValid</a>(<span class="keywordtype">bool</span> aSecurityValid) { mSecurityValid = aSecurityValid; }</div><div class="line"><a name="l00616"></a><span class="lineno">  616</span>&#160;</div><div class="line"><a name="l00623"></a><span class="lineno"><a class="line" href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#a44442235fb512b633c81726b97e7e441">  623</a></span>&#160;    uint8_t <a class="code" href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#a44442235fb512b633c81726b97e7e441">GetPsduLength</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mLength; }</div><div class="line"><a name="l00624"></a><span class="lineno">  624</span>&#160;</div><div class="line"><a name="l00631"></a><span class="lineno"><a class="line" href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#a1d52519678ee06d6e23481aaad1407e9">  631</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#a1d52519678ee06d6e23481aaad1407e9">SetPsduLength</a>(uint8_t aLength) { mLength = aLength; }</div><div class="line"><a name="l00632"></a><span class="lineno">  632</span>&#160;</div><div class="line"><a name="l00639"></a><span class="lineno"><a class="line" href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#aebe2c17f0f922618d8d9de522ca66ae7">  639</a></span>&#160;    uint8_t *<a class="code" href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#aebe2c17f0f922618d8d9de522ca66ae7">GetPsdu</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mPsdu; }</div><div class="line"><a name="l00640"></a><span class="lineno">  640</span>&#160;</div><div class="line"><a name="l00647"></a><span class="lineno">  647</span>&#160;    uint8_t *GetHeader(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00648"></a><span class="lineno">  648</span>&#160;</div><div class="line"><a name="l00655"></a><span class="lineno">  655</span>&#160;    uint8_t *GetPayload(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00656"></a><span class="lineno">  656</span>&#160;</div><div class="line"><a name="l00663"></a><span class="lineno">  663</span>&#160;    uint8_t *GetFooter(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00664"></a><span class="lineno">  664</span>&#160;</div><div class="line"><a name="l00665"></a><span class="lineno">  665</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00666"></a><span class="lineno">  666</span>&#160;    <span class="keyword">enum</span></div><div class="line"><a name="l00667"></a><span class="lineno">  667</span>&#160;    {</div><div class="line"><a name="l00668"></a><span class="lineno">  668</span>&#160;        kKeyIdLengthMode0 = 0,   </div><div class="line"><a name="l00669"></a><span class="lineno">  669</span>&#160;        kKeyIdLengthMode1 = 1,   </div><div class="line"><a name="l00670"></a><span class="lineno">  670</span>&#160;        kKeyIdLengthMode2 = 5,   </div><div class="line"><a name="l00671"></a><span class="lineno">  671</span>&#160;        kKeyIdLengthMode3 = 9,   </div><div class="line"><a name="l00672"></a><span class="lineno">  672</span>&#160;    };</div><div class="line"><a name="l00673"></a><span class="lineno">  673</span>&#160;</div><div class="line"><a name="l00674"></a><span class="lineno">  674</span>&#160;    uint8_t *FindSequence(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00675"></a><span class="lineno">  675</span>&#160;    uint8_t *FindDstPanId(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00676"></a><span class="lineno">  676</span>&#160;    uint8_t *FindDstAddr(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00677"></a><span class="lineno">  677</span>&#160;    uint8_t *FindSrcPanId(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00678"></a><span class="lineno">  678</span>&#160;    uint8_t *FindSrcAddr(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00679"></a><span class="lineno">  679</span>&#160;    uint8_t *FindSecurityHeader(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00680"></a><span class="lineno">  680</span>&#160;};</div><div class="line"><a name="l00681"></a><span class="lineno">  681</span>&#160;</div><div class="line"><a name="l00686"></a><span class="lineno"><a class="line" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html">  686</a></span>&#160;<span class="keyword">class </span><a class="code" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html">Beacon</a></div><div class="line"><a name="l00687"></a><span class="lineno">  687</span>&#160;{</div><div class="line"><a name="l00688"></a><span class="lineno">  688</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00689"></a><span class="lineno">  689</span>&#160;    <span class="keyword">enum</span></div><div class="line"><a name="l00690"></a><span class="lineno">  690</span>&#160;    {</div><div class="line"><a name="l00691"></a><span class="lineno"><a class="line" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a56ac111106a0b9fadec5020db9a9c867a6156678084c0889a6804674590c41f4d">  691</a></span>&#160;        kSuperFrameSpec   = 0x0fff,                 </div><div class="line"><a name="l00692"></a><span class="lineno"><a class="line" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a56ac111106a0b9fadec5020db9a9c867a47e94cbbb7655d0bee8085cf93ea0fa4">  692</a></span>&#160;        kProtocolId       = 3,                      </div><div class="line"><a name="l00693"></a><span class="lineno"><a class="line" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a56ac111106a0b9fadec5020db9a9c867ab0616da9da16a31ff17d9e0415d6c3d6">  693</a></span>&#160;        kNetworkNameSize  = 16,                     </div><div class="line"><a name="l00694"></a><span class="lineno"><a class="line" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a56ac111106a0b9fadec5020db9a9c867a3fd603d529fbb5feec598a0781262a24">  694</a></span>&#160;        kExtPanIdSize     = 8,                      </div><div class="line"><a name="l00695"></a><span class="lineno">  695</span>&#160;    };</div><div class="line"><a name="l00696"></a><span class="lineno">  696</span>&#160;</div><div class="line"><a name="l00697"></a><span class="lineno">  697</span>&#160;    <span class="keyword">enum</span></div><div class="line"><a name="l00698"></a><span class="lineno">  698</span>&#160;    {</div><div class="line"><a name="l00699"></a><span class="lineno"><a class="line" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a494f84956761acbd22e12352f79af2b5a8f7cdc1952344c6b0831f854e4f29bd4">  699</a></span>&#160;        kProtocolVersion  = 2,                      </div><div class="line"><a name="l00700"></a><span class="lineno"><a class="line" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a494f84956761acbd22e12352f79af2b5aadc1e7b98e71f6b0e125fe90a1e011c6">  700</a></span>&#160;        kVersionOffset    = 4,                      </div><div class="line"><a name="l00701"></a><span class="lineno"><a class="line" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a494f84956761acbd22e12352f79af2b5aaca643acb644addc7a7967e53740265e">  701</a></span>&#160;        kVersionMask      = 0xf &lt;&lt; kVersionOffset,  </div><div class="line"><a name="l00702"></a><span class="lineno"><a class="line" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a494f84956761acbd22e12352f79af2b5a31d9c18e75d86b2629aa8452dc9a6cef">  702</a></span>&#160;        kNativeFlag       = 1 &lt;&lt; 3,                 </div><div class="line"><a name="l00703"></a><span class="lineno"><a class="line" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a494f84956761acbd22e12352f79af2b5a1a33cba4f743ac65d4b10c6c6039c759">  703</a></span>&#160;        kJoiningFlag      = 1 &lt;&lt; 0,                 </div><div class="line"><a name="l00704"></a><span class="lineno">  704</span>&#160;    };</div><div class="line"><a name="l00705"></a><span class="lineno">  705</span>&#160;</div><div class="line"><a name="l00710"></a><span class="lineno"><a class="line" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#aa81f013fe7fa5d8b17c430f2401c81c1">  710</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#aa81f013fe7fa5d8b17c430f2401c81c1">Init</a>(<span class="keywordtype">void</span>) {</div><div class="line"><a name="l00711"></a><span class="lineno">  711</span>&#160;        mSuperframeSpec = Thread::Encoding::LittleEndian::HostSwap16(kSuperFrameSpec);</div><div class="line"><a name="l00712"></a><span class="lineno">  712</span>&#160;        mGtsSpec = 0;</div><div class="line"><a name="l00713"></a><span class="lineno">  713</span>&#160;        mPendingAddressSpec = 0;</div><div class="line"><a name="l00714"></a><span class="lineno">  714</span>&#160;        mProtocolId = kProtocolId;</div><div class="line"><a name="l00715"></a><span class="lineno">  715</span>&#160;        mFlags = kProtocolVersion &lt;&lt; kVersionOffset;</div><div class="line"><a name="l00716"></a><span class="lineno">  716</span>&#160;    }</div><div class="line"><a name="l00717"></a><span class="lineno">  717</span>&#160;</div><div class="line"><a name="l00725"></a><span class="lineno"><a class="line" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a10e6500148f827f5ad357dcf657954aa">  725</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a10e6500148f827f5ad357dcf657954aa">IsValid</a>(<span class="keywordtype">void</span>) {</div><div class="line"><a name="l00726"></a><span class="lineno">  726</span>&#160;        <span class="keywordflow">return</span> (mSuperframeSpec == Thread::Encoding::LittleEndian::HostSwap16(kSuperFrameSpec)) &amp;&amp;</div><div class="line"><a name="l00727"></a><span class="lineno">  727</span>&#160;               (mGtsSpec == 0) &amp;&amp; (mPendingAddressSpec == 0) &amp;&amp; (mProtocolId == kProtocolId);</div><div class="line"><a name="l00728"></a><span class="lineno">  728</span>&#160;    }</div><div class="line"><a name="l00729"></a><span class="lineno">  729</span>&#160;</div><div class="line"><a name="l00736"></a><span class="lineno"><a class="line" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#ac9237b6b7c0e43cc6fe7fa9228fae2e7">  736</a></span>&#160;    uint8_t <a class="code" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#ac9237b6b7c0e43cc6fe7fa9228fae2e7">GetProtocolId</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mProtocolId; }</div><div class="line"><a name="l00737"></a><span class="lineno">  737</span>&#160;</div><div class="line"><a name="l00744"></a><span class="lineno"><a class="line" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#ad7828526fc39221bdcf4ba4e5fe9ab07">  744</a></span>&#160;    uint8_t <a class="code" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#ad7828526fc39221bdcf4ba4e5fe9ab07">GetProtocolVersion</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mFlags &gt;&gt; kVersionOffset; }</div><div class="line"><a name="l00745"></a><span class="lineno">  745</span>&#160;</div><div class="line"><a name="l00753"></a><span class="lineno"><a class="line" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a0343fa8c7baafb84d456726952d9964f">  753</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a0343fa8c7baafb84d456726952d9964f">IsNative</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (mFlags &amp; kNativeFlag) != 0; }</div><div class="line"><a name="l00754"></a><span class="lineno">  754</span>&#160;</div><div class="line"><a name="l00759"></a><span class="lineno"><a class="line" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a6025c99678cf4cbaf9573c40b158e7e7">  759</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a6025c99678cf4cbaf9573c40b158e7e7">ClearNative</a>(<span class="keywordtype">void</span>) { mFlags &amp;= ~kNativeFlag; }</div><div class="line"><a name="l00760"></a><span class="lineno">  760</span>&#160;</div><div class="line"><a name="l00765"></a><span class="lineno"><a class="line" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#ab7dbe2fe38bc9a6dc6cb663fc5c66d86">  765</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#ab7dbe2fe38bc9a6dc6cb663fc5c66d86">SetNative</a>(<span class="keywordtype">void</span>) { mFlags |= kNativeFlag; }</div><div class="line"><a name="l00766"></a><span class="lineno">  766</span>&#160;</div><div class="line"><a name="l00774"></a><span class="lineno"><a class="line" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a6ef668a43c1a57f0a245636a7caac4cf">  774</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a6ef668a43c1a57f0a245636a7caac4cf">IsJoiningPermitted</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (mFlags &amp; kJoiningFlag) != 0; }</div><div class="line"><a name="l00775"></a><span class="lineno">  775</span>&#160;</div><div class="line"><a name="l00780"></a><span class="lineno"><a class="line" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a8be37c57b5d825c4835a91533636c849">  780</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a8be37c57b5d825c4835a91533636c849">ClearJoiningPermitted</a>(<span class="keywordtype">void</span>) { mFlags &amp;= ~kJoiningFlag; }</div><div class="line"><a name="l00781"></a><span class="lineno">  781</span>&#160;</div><div class="line"><a name="l00786"></a><span class="lineno"><a class="line" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a335c1b39b612834e030aa1100030958d">  786</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a335c1b39b612834e030aa1100030958d">SetJoiningPermitted</a>(<span class="keywordtype">void</span>) { mFlags |= kJoiningFlag; }</div><div class="line"><a name="l00787"></a><span class="lineno">  787</span>&#160;</div><div class="line"><a name="l00794"></a><span class="lineno"><a class="line" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#ad91c508e53d38100e96f22eb81ffb174">  794</a></span>&#160;    <span class="keyword">const</span> <span class="keywordtype">char</span> *<a class="code" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#ad91c508e53d38100e96f22eb81ffb174">GetNetworkName</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mNetworkName; }</div><div class="line"><a name="l00795"></a><span class="lineno">  795</span>&#160;</div><div class="line"><a name="l00802"></a><span class="lineno"><a class="line" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a3f4c8086af85d09b65d35fa0c13edef1">  802</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a3f4c8086af85d09b65d35fa0c13edef1">SetNetworkName</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *aNetworkName) {</div><div class="line"><a name="l00803"></a><span class="lineno">  803</span>&#160;        <span class="keywordtype">size_t</span> length = strnlen(aNetworkName, <span class="keyword">sizeof</span>(mNetworkName));</div><div class="line"><a name="l00804"></a><span class="lineno">  804</span>&#160;        memset(mNetworkName, 0, <span class="keyword">sizeof</span>(mNetworkName));</div><div class="line"><a name="l00805"></a><span class="lineno">  805</span>&#160;        memcpy(mNetworkName, aNetworkName, length);</div><div class="line"><a name="l00806"></a><span class="lineno">  806</span>&#160;    }</div><div class="line"><a name="l00807"></a><span class="lineno">  807</span>&#160;</div><div class="line"><a name="l00814"></a><span class="lineno"><a class="line" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#aa4462abfadb71bc9837eb67268bc053c">  814</a></span>&#160;    <span class="keyword">const</span> uint8_t *<a class="code" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#aa4462abfadb71bc9837eb67268bc053c">GetExtendedPanId</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mExtendedPanId; }</div><div class="line"><a name="l00815"></a><span class="lineno">  815</span>&#160;</div><div class="line"><a name="l00822"></a><span class="lineno"><a class="line" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#ad12ac64e6477dc001e11895e20d43da7">  822</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#ad12ac64e6477dc001e11895e20d43da7">SetExtendedPanId</a>(<span class="keyword">const</span> uint8_t *aExtPanId) { memcpy(mExtendedPanId, aExtPanId, <span class="keyword">sizeof</span>(mExtendedPanId)); }</div><div class="line"><a name="l00823"></a><span class="lineno">  823</span>&#160;</div><div class="line"><a name="l00824"></a><span class="lineno">  824</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00825"></a><span class="lineno">  825</span>&#160;    uint16_t mSuperframeSpec;</div><div class="line"><a name="l00826"></a><span class="lineno">  826</span>&#160;    uint8_t  mGtsSpec;</div><div class="line"><a name="l00827"></a><span class="lineno">  827</span>&#160;    uint8_t  mPendingAddressSpec;</div><div class="line"><a name="l00828"></a><span class="lineno">  828</span>&#160;    uint8_t  mProtocolId;</div><div class="line"><a name="l00829"></a><span class="lineno">  829</span>&#160;    uint8_t  mFlags;</div><div class="line"><a name="l00830"></a><span class="lineno">  830</span>&#160;    <span class="keywordtype">char</span>     mNetworkName[kNetworkNameSize];</div><div class="line"><a name="l00831"></a><span class="lineno">  831</span>&#160;    uint8_t  mExtendedPanId[kExtPanIdSize];</div><div class="line"><a name="l00832"></a><span class="lineno">  832</span>&#160;} <a class="code" href="../../d7/da1/group__toolchain.html#gacf07d7a4a2ea6d0cc3426234565fcb7b">OT_TOOL_PACKED_END</a>;</div><div class="line"><a name="l00833"></a><span class="lineno">  833</span>&#160;</div><div class="line"><a name="l00839"></a><span class="lineno">  839</span>&#160;}  <span class="comment">// namespace Mac</span></div><div class="line"><a name="l00840"></a><span class="lineno">  840</span>&#160;}  <span class="comment">// namespace Thread</span></div><div class="line"><a name="l00841"></a><span class="lineno">  841</span>&#160;</div><div class="line"><a name="l00842"></a><span class="lineno">  842</span>&#160;<span class="preprocessor">#endif  // MAC_FRAME_HPP_</span></div><div class="ttc" id="group__core-mac_html_gafb4cc58e5e57ede04e2dbeb02f230ae1"><div class="ttname"><a href="../../df/d5c/group__core-mac.html#gafb4cc58e5e57ede04e2dbeb02f230ae1">Thread::Mac::PanId</a></div><div class="ttdeci">otPanId PanId</div><div class="ttdoc">This type represents the IEEE 802.15.4 PAN ID. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:69</div></div>
<div class="ttc" id="radio_8h_html"><div class="ttname"><a href="../../d7/d62/radio_8h.html">radio.h</a></div><div class="ttdoc">This file defines the radio interface for OpenThread. </div></div>
<div class="ttc" id="structThread_1_1Mac_1_1Address_html_af0811fa6871a4011a107fe7416f4b09e"><div class="ttname"><a href="../../dd/dcd/structThread_1_1Mac_1_1Address.html#af0811fa6871a4011a107fe7416f4b09e">Thread::Mac::Address::mLength</a></div><div class="ttdeci">uint8_t mLength</div><div class="ttdoc">Length of address in bytes. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:154</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1Beacon_html_ad7828526fc39221bdcf4ba4e5fe9ab07"><div class="ttname"><a href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#ad7828526fc39221bdcf4ba4e5fe9ab07">Thread::Mac::Beacon::GetProtocolVersion</a></div><div class="ttdeci">uint8_t GetProtocolVersion(void) const </div><div class="ttdoc">This method returns the Protocol Version value. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:744</div></div>
<div class="ttc" id="openthread-types_8h_html_ab701d053a9c34ab7f11e43e0dc09ac9f"><div class="ttname"><a href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a></div><div class="ttdeci">ThreadError</div><div class="ttdoc">This enumeration represents error codes used throughout OpenThread. </div><div class="ttdef"><b>Definition:</b> openthread-types.h:75</div></div>
<div class="ttc" id="group__core-mac_html_ga70635fe32761138510f029f3d4eb36b7"><div class="ttname"><a href="../../df/d5c/group__core-mac.html#ga70635fe32761138510f029f3d4eb36b7">Thread::Mac::ShortAddress</a></div><div class="ttdeci">otShortAddress ShortAddress</div><div class="ttdoc">This type represents the IEEE 802.15.4 Short Address. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:75</div></div>
<div class="ttc" id="structThread_1_1Mac_1_1Address_html_aeec7c8fde272afa865ba668174335040"><div class="ttname"><a href="../../dd/dcd/structThread_1_1Mac_1_1Address.html#aeec7c8fde272afa865ba668174335040">Thread::Mac::Address::mShortAddress</a></div><div class="ttdeci">ShortAddress mShortAddress</div><div class="ttdoc">The IEEE 802.15.4 Short Address. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:157</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1Frame_html_a1d52519678ee06d6e23481aaad1407e9"><div class="ttname"><a href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#a1d52519678ee06d6e23481aaad1407e9">Thread::Mac::Frame::SetPsduLength</a></div><div class="ttdeci">void SetPsduLength(uint8_t aLength)</div><div class="ttdoc">This method sets the IEEE 802.15.4 PSDU length. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:631</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1Beacon_html_a6ef668a43c1a57f0a245636a7caac4cf"><div class="ttname"><a href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a6ef668a43c1a57f0a245636a7caac4cf">Thread::Mac::Beacon::IsJoiningPermitted</a></div><div class="ttdeci">bool IsJoiningPermitted(void) const </div><div class="ttdoc">This method indicates whether or not the Joining Permitted flag is set. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:774</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1Frame_html_a1d0d834e9d25cd755f00b0de75ba9f89"><div class="ttname"><a href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#a1d0d834e9d25cd755f00b0de75ba9f89">Thread::Mac::Frame::GetLqi</a></div><div class="ttdeci">uint8_t GetLqi(void) const </div><div class="ttdoc">This method returns the receive Link Quality Indicator. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:590</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1Beacon_html_a10e6500148f827f5ad357dcf657954aa"><div class="ttname"><a href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a10e6500148f827f5ad357dcf657954aa">Thread::Mac::Beacon::IsValid</a></div><div class="ttdeci">bool IsValid(void)</div><div class="ttdoc">This method indicates whether or not the beacon appears to be a valid Thread Beacon message...</div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:725</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1Beacon_html_aa81f013fe7fa5d8b17c430f2401c81c1"><div class="ttname"><a href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#aa81f013fe7fa5d8b17c430f2401c81c1">Thread::Mac::Beacon::Init</a></div><div class="ttdeci">void Init(void)</div><div class="ttdoc">This method initializes the Beacon message. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:710</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1Beacon_html_a6025c99678cf4cbaf9573c40b158e7e7"><div class="ttname"><a href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a6025c99678cf4cbaf9573c40b158e7e7">Thread::Mac::Beacon::ClearNative</a></div><div class="ttdeci">void ClearNative(void)</div><div class="ttdoc">This method clears the Native Commissioner flag. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:759</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1Frame_html_a09c3c9cbba9064e95c0224a637920930"><div class="ttname"><a href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#a09c3c9cbba9064e95c0224a637920930">Thread::Mac::Frame::SetLqi</a></div><div class="ttdeci">void SetLqi(uint8_t aLqi)</div><div class="ttdoc">This method sets the receive Link Quality Indicator. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:598</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1Beacon_html_a335c1b39b612834e030aa1100030958d"><div class="ttname"><a href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a335c1b39b612834e030aa1100030958d">Thread::Mac::Beacon::SetJoiningPermitted</a></div><div class="ttdeci">void SetJoiningPermitted(void)</div><div class="ttdoc">This method sets the Joining Permitted flag. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:786</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1Frame_html_ac3d7050937855b460dca12d48568b47c"><div class="ttname"><a href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#ac3d7050937855b460dca12d48568b47c">Thread::Mac::Frame::GetChannel</a></div><div class="ttdeci">uint8_t GetChannel(void) const </div><div class="ttdoc">This method returns the IEEE 802.15.4 channel used for transmission or reception. ...</div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:558</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1Beacon_html_a3f4c8086af85d09b65d35fa0c13edef1"><div class="ttname"><a href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a3f4c8086af85d09b65d35fa0c13edef1">Thread::Mac::Beacon::SetNetworkName</a></div><div class="ttdeci">void SetNetworkName(const char *aNetworkName)</div><div class="ttdoc">This method sets the Network Name field. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:802</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1Beacon_html_aa4462abfadb71bc9837eb67268bc053c"><div class="ttname"><a href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#aa4462abfadb71bc9837eb67268bc053c">Thread::Mac::Beacon::GetExtendedPanId</a></div><div class="ttdeci">const uint8_t * GetExtendedPanId(void) const </div><div class="ttdoc">This method returns a pointer to the Extended PAN ID field. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:814</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1Beacon_html_a0343fa8c7baafb84d456726952d9964f"><div class="ttname"><a href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a0343fa8c7baafb84d456726952d9964f">Thread::Mac::Beacon::IsNative</a></div><div class="ttdeci">bool IsNative(void) const </div><div class="ttdoc">This method indicates whether or not the Native Commissioner flag is set. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:753</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1Frame_html_a3bfa54c09049320ffa71d29d413ba223"><div class="ttname"><a href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#a3bfa54c09049320ffa71d29d413ba223">Thread::Mac::Frame::GetSecurityValid</a></div><div class="ttdeci">bool GetSecurityValid(void) const </div><div class="ttdoc">This method indicates whether or not frame security was enabled and passed security validation...</div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:607</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1ExtAddress_html_a43917c9fe781b643eb1309b047c9d08b"><div class="ttname"><a href="../../d9/d3c/classThread_1_1Mac_1_1ExtAddress.html#a43917c9fe781b643eb1309b047c9d08b">Thread::Mac::ExtAddress::IsLocal</a></div><div class="ttdeci">bool IsLocal(void) const </div><div class="ttdoc">This method indicates whether or not the Local bit is set. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:115</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1Beacon_html_a8be37c57b5d825c4835a91533636c849"><div class="ttname"><a href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#a8be37c57b5d825c4835a91533636c849">Thread::Mac::Beacon::ClearJoiningPermitted</a></div><div class="ttdeci">void ClearJoiningPermitted(void)</div><div class="ttdoc">This method clears the Joining Permitted flag. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:780</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1ExtAddress_html_a846827d778c476fb5c5c059903efc4fb"><div class="ttname"><a href="../../d9/d3c/classThread_1_1Mac_1_1ExtAddress.html#a846827d778c476fb5c5c059903efc4fb">Thread::Mac::ExtAddress::SetLocal</a></div><div class="ttdeci">void SetLocal(bool aLocal)</div><div class="ttdoc">This method sets the Local bit. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:123</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1Beacon_html"><div class="ttname"><a href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html">Thread::Mac::Beacon</a></div><div class="ttdoc">This class implements IEEE 802.15.4 Beacon generation and parsing. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:686</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1Frame_html_a93887aa34760b4de326cee1ff3d83b75"><div class="ttname"><a href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#a93887aa34760b4de326cee1ff3d83b75">Thread::Mac::Frame::SetChannel</a></div><div class="ttdeci">void SetChannel(uint8_t aChannel)</div><div class="ttdoc">This method sets the IEEE 802.15.4 channel used for transmission or reception. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:566</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1ExtAddress_html_a46495e874468bb305e1e3ddc410a16d0"><div class="ttname"><a href="../../d9/d3c/classThread_1_1Mac_1_1ExtAddress.html#a46495e874468bb305e1e3ddc410a16d0">Thread::Mac::ExtAddress::SetGroup</a></div><div class="ttdeci">void SetGroup(bool aGroup)</div><div class="ttdoc">This method sets the Group bit. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:99</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1Frame_html_adad1e326ec1c3bf027a0e6e485f178b8"><div class="ttname"><a href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#adad1e326ec1c3bf027a0e6e485f178b8">Thread::Mac::Frame::SetSecurityValid</a></div><div class="ttdeci">void SetSecurityValid(bool aSecurityValid)</div><div class="ttdoc">This method sets the security valid attribute. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:615</div></div>
<div class="ttc" id="encoding_8hpp_html"><div class="ttname"><a href="../../df/d57/encoding_8hpp.html">encoding.hpp</a></div><div class="ttdoc">This file includes definitions for byte-ordering encoding. </div></div>
<div class="ttc" id="structotExtAddress_html"><div class="ttname"><a href="../../d3/d8f/structotExtAddress.html">otExtAddress</a></div><div class="ttdoc">This type represents the IEEE 802.15.4 Extended Address. </div><div class="ttdef"><b>Definition:</b> openthread-types.h:274</div></div>
<div class="ttc" id="group__toolchain_html_gacf07d7a4a2ea6d0cc3426234565fcb7b"><div class="ttname"><a href="../../d7/da1/group__toolchain.html#gacf07d7a4a2ea6d0cc3426234565fcb7b">OT_TOOL_PACKED_END</a></div><div class="ttdeci">#define OT_TOOL_PACKED_END</div><div class="ttdoc">Compiler-specific indication at the end of a byte packed class or struct. </div><div class="ttdef"><b>Definition:</b> toolchain.h:131</div></div>
<div class="ttc" id="structThread_1_1Mac_1_1Address_html"><div class="ttname"><a href="../../dd/dcd/structThread_1_1Mac_1_1Address.html">Thread::Mac::Address</a></div><div class="ttdoc">This structure represents an IEEE 802.15.4 Short or Extended Address. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:152</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1Frame_html_aebe2c17f0f922618d8d9de522ca66ae7"><div class="ttname"><a href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#aebe2c17f0f922618d8d9de522ca66ae7">Thread::Mac::Frame::GetPsdu</a></div><div class="ttdeci">uint8_t * GetPsdu(void)</div><div class="ttdoc">This method returns a pointer to the PSDU. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:639</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1ExtAddress_html_a0dc2551c0ecb13f87ab257c4c760396b"><div class="ttname"><a href="../../d9/d3c/classThread_1_1Mac_1_1ExtAddress.html#a0dc2551c0ecb13f87ab257c4c760396b">Thread::Mac::ExtAddress::IsGroup</a></div><div class="ttdeci">bool IsGroup(void) const </div><div class="ttdoc">This method indicates whether or not the Group bit is set. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:91</div></div>
<div class="ttc" id="structRadioPacket_html"><div class="ttname"><a href="../../db/ddc/structRadioPacket.html">RadioPacket</a></div><div class="ttdoc">This structure represents an IEEE 802.15.4 radio frame. </div><div class="ttdef"><b>Definition:</b> radio.h:98</div></div>
<div class="ttc" id="openthread-types_8h_html_a2dd7c7e7e4b5a8a15e9af7fb78de1eda"><div class="ttname"><a href="../../dc/dbf/openthread-types_8h.html#a2dd7c7e7e4b5a8a15e9af7fb78de1eda">otPanId</a></div><div class="ttdeci">uint16_t otPanId</div><div class="ttdoc">This type represents the IEEE 802.15.4 PAN ID. </div><div class="ttdef"><b>Definition:</b> openthread-types.h:260</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1Beacon_html_ac9237b6b7c0e43cc6fe7fa9228fae2e7"><div class="ttname"><a href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#ac9237b6b7c0e43cc6fe7fa9228fae2e7">Thread::Mac::Beacon::GetProtocolId</a></div><div class="ttdeci">uint8_t GetProtocolId(void) const </div><div class="ttdoc">This method returns the Protocol ID value. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:736</div></div>
<div class="ttc" id="openthread-types_8h_html"><div class="ttname"><a href="../../dc/dbf/openthread-types_8h.html">openthread-types.h</a></div><div class="ttdoc">This file defines the types and structures used in the OpenThread library API. </div></div>
<div class="ttc" id="classThread_1_1Mac_1_1Frame_html"><div class="ttname"><a href="../../d5/d19/classThread_1_1Mac_1_1Frame.html">Thread::Mac::Frame</a></div><div class="ttdoc">This class implements IEEE 802.15.4 MAC frame generation and parsing. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:167</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1Beacon_html_ad12ac64e6477dc001e11895e20d43da7"><div class="ttname"><a href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#ad12ac64e6477dc001e11895e20d43da7">Thread::Mac::Beacon::SetExtendedPanId</a></div><div class="ttdeci">void SetExtendedPanId(const uint8_t *aExtPanId)</div><div class="ttdoc">This method sets the Extended PAN ID field. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:822</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1Frame_html_a44442235fb512b633c81726b97e7e441"><div class="ttname"><a href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#a44442235fb512b633c81726b97e7e441">Thread::Mac::Frame::GetPsduLength</a></div><div class="ttdeci">uint8_t GetPsduLength(void) const </div><div class="ttdoc">This method returns the IEEE 802.15.4 PSDU length. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:623</div></div>
<div class="ttc" id="structThread_1_1Mac_1_1Address_html_a349a0360c664b5aefef89bb537b810d3"><div class="ttname"><a href="../../dd/dcd/structThread_1_1Mac_1_1Address.html#a349a0360c664b5aefef89bb537b810d3">Thread::Mac::Address::mExtAddress</a></div><div class="ttdeci">ExtAddress mExtAddress</div><div class="ttdoc">The IEEE 802.15.4 Extended Address. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:158</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1Beacon_html_ab7dbe2fe38bc9a6dc6cb663fc5c66d86"><div class="ttname"><a href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#ab7dbe2fe38bc9a6dc6cb663fc5c66d86">Thread::Mac::Beacon::SetNative</a></div><div class="ttdeci">void SetNative(void)</div><div class="ttdoc">This method sets the Native Commissioner flag. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:765</div></div>
<div class="ttc" id="group__toolchain_html_gaba6ad63129c3a790957a9b149a65891b"><div class="ttname"><a href="../../d7/da1/group__toolchain.html#gaba6ad63129c3a790957a9b149a65891b">OT_TOOL_PACKED_BEGIN</a></div><div class="ttdeci">#define OT_TOOL_PACKED_BEGIN</div><div class="ttdoc">Compiler-specific indication that a class or struct must be byte packed. </div><div class="ttdef"><b>Definition:</b> toolchain.h:129</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1ExtAddress_html"><div class="ttname"><a href="../../d9/d3c/classThread_1_1Mac_1_1ExtAddress.html">Thread::Mac::ExtAddress</a></div><div class="ttdoc">This structure represents an IEEE 802.15.4 Extended Address. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:81</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1Beacon_html_ad91c508e53d38100e96f22eb81ffb174"><div class="ttname"><a href="../../dc/dbd/classThread_1_1Mac_1_1Beacon.html#ad91c508e53d38100e96f22eb81ffb174">Thread::Mac::Beacon::GetNetworkName</a></div><div class="ttdeci">const char * GetNetworkName(void) const </div><div class="ttdoc">This method returns a pointer to the Network Name field. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:794</div></div>
<div class="ttc" id="namespaceThread_html"><div class="ttname"><a href="../../d9/d00/namespaceThread.html">Thread</a></div><div class="ttdef"><b>Definition:</b> cli.cpp:61</div></div>
<div class="ttc" id="openthread-types_8h_html_a9199b7f0fe13ebcd0da2e3af71f04c40"><div class="ttname"><a href="../../dc/dbf/openthread-types_8h.html#a9199b7f0fe13ebcd0da2e3af71f04c40">otShortAddress</a></div><div class="ttdeci">uint16_t otShortAddress</div><div class="ttdoc">This type represents the IEEE 802.15.4 Short Address. </div><div class="ttdef"><b>Definition:</b> openthread-types.h:266</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1Frame_html_a610b5a57124838a4e45ea7c4ec702166"><div class="ttname"><a href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#a610b5a57124838a4e45ea7c4ec702166">Thread::Mac::Frame::GetPower</a></div><div class="ttdeci">int8_t GetPower(void) const </div><div class="ttdoc">This method returns the transmit/receive power in dBm used for transmission or reception. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:574</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1Frame_html_a0eeddf23b24e968ad5c025b0143dcc4a"><div class="ttname"><a href="../../d5/d19/classThread_1_1Mac_1_1Frame.html#a0eeddf23b24e968ad5c025b0143dcc4a">Thread::Mac::Frame::SetPower</a></div><div class="ttdeci">void SetPower(int8_t aPower)</div><div class="ttdoc">This method sets the transmit/receive power in dBm used for transmission or reception. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:582</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1Address_html"><div class="ttname"><a href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Thread::Ip6::Address</a></div><div class="ttdoc">This class implements an IPv6 address object. </div><div class="ttdef"><b>Definition:</b> ip6_address.hpp:56</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="../../dir_aebb8dcc11953d78e620bbef0b9e2183.html">core</a></li><li class="navelem"><a class="el" href="../../dir_4f2226f7ee388b01e44ffc735c8969ec.html">mac</a></li><li class="navelem"><a class="el" href="../../d1/d97/mac__frame_8hpp.html">mac_frame.hpp</a></li>
    <li class="footer">Generated on Fri Oct 14 2016 08:44:33 for OpenThread by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="../../doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
